---
- name: Setup UFW Firewall
  block:
    - name: Gather package facts
      ansible.builtin.package_facts:
        manager: auto  # auto will automatically detect the package manager

    - name: Check if a package is installed
      ansible.builtin.fail:
        msg: "'{{ item }}' is not installed!"
      when: item not in ansible_facts.packages
      with_items:
        - ufw

    - name: Allow SSH through UFW
      ansible.builtin.ufw:
        rule: allow
        name: OpenSSH

    - name: Enable UFW
      ansible.builtin.ufw:
        state: enabled
        policy: reject
        direction: incoming
  become: yes
